#ifndef INCLUDED_COM_SUN_STAR_LANG_ILLEGALARGUMENTEXCEPTION_HPP
#define INCLUDED_COM_SUN_STAR_LANG_ILLEGALARGUMENTEXCEPTION_HPP

#include "sal/config.h"

#include "com/sun/star/lang/IllegalArgumentException.hdl"

#include "com/sun/star/uno/Exception.hpp"
#include "com/sun/star/uno/Type.hxx"
#include "cppu/unotype.hxx"
#include "osl/mutex.hxx"
#include "sal/types.h"

namespace com { namespace sun { namespace star { namespace lang {

inline IllegalArgumentException::IllegalArgumentException() SAL_THROW( () )
    : ::com::sun::star::uno::Exception()
    , ArgumentPosition(0)
{
    ::cppu::UnoType< ::com::sun::star::lang::IllegalArgumentException >::get();
}

inline IllegalArgumentException::IllegalArgumentException(const ::rtl::OUString& Message_, const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >& Context_, const ::sal_Int16& ArgumentPosition_) SAL_THROW( () )
    : ::com::sun::star::uno::Exception(Message_, Context_)
    , ArgumentPosition(ArgumentPosition_)
{
    ::cppu::UnoType< ::com::sun::star::lang::IllegalArgumentException >::get();
}

IllegalArgumentException::IllegalArgumentException(IllegalArgumentException const & the_other): ::com::sun::star::uno::Exception(the_other), ArgumentPosition(the_other.ArgumentPosition) {}

IllegalArgumentException::~IllegalArgumentException() {}

IllegalArgumentException & IllegalArgumentException::operator =(IllegalArgumentException const & the_other) {
    //TODO: Just like its implicitly-defined counterpart, this function definition is not exception-safe
    ::com::sun::star::uno::Exception::operator =(the_other);
    ArgumentPosition = the_other.ArgumentPosition;
    return *this;
}

} } } }

namespace com { namespace sun { namespace star { namespace lang {

inline ::com::sun::star::uno::Type const & cppu_detail_getUnoType(::com::sun::star::lang::IllegalArgumentException const *) {
    static ::com::sun::star::uno::Type * the_pType = 0;
    if (the_pType == 0)
    {
        ::osl::MutexGuard aGuard( ::osl::Mutex::getGlobalMutex() );
        if (the_pType == 0)
        {
            ::rtl::OUString sTypeName( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.lang.IllegalArgumentException") );

            // Start inline typedescription generation
            typelib_TypeDescription * pTD = 0;
            const ::com::sun::star::uno::Type& rSuperType = ::cppu::UnoType< ::com::sun::star::uno::Exception >::get();

            typelib_CompoundMember_Init aMembers[1];
            ::rtl::OUString sMemberType0( RTL_CONSTASCII_USTRINGPARAM("short") );
            ::rtl::OUString sMemberName0( RTL_CONSTASCII_USTRINGPARAM("ArgumentPosition") );
            aMembers[0].eTypeClass = (typelib_TypeClass)::com::sun::star::uno::TypeClass_SHORT;
            aMembers[0].pTypeName = sMemberType0.pData;
            aMembers[0].pMemberName = sMemberName0.pData;

            typelib_typedescription_new(
                &pTD,
                (typelib_TypeClass)::com::sun::star::uno::TypeClass_EXCEPTION, sTypeName.pData,
                rSuperType.getTypeLibType(),
                1,
                aMembers );

            typelib_typedescription_register( (typelib_TypeDescription**)&pTD );

            typelib_typedescription_release( pTD );
            // End inline typedescription generation

            static ::com::sun::star::uno::Type the_staticType( ::com::sun::star::uno::TypeClass_EXCEPTION, sTypeName );
            the_pType = &the_staticType;
        }
    }

    return *the_pType;
}

} } } }

inline ::com::sun::star::uno::Type const & SAL_CALL getCppuType(::com::sun::star::lang::IllegalArgumentException const *) SAL_THROW(()) {
    return ::cppu::UnoType< ::com::sun::star::lang::IllegalArgumentException >::get();
}

#endif // INCLUDED_COM_SUN_STAR_LANG_ILLEGALARGUMENTEXCEPTION_HPP
