#ifndef INCLUDED_COM_SUN_STAR_LANG_WRAPPEDTARGETEXCEPTION_HPP
#define INCLUDED_COM_SUN_STAR_LANG_WRAPPEDTARGETEXCEPTION_HPP

#include "sal/config.h"

#include "com/sun/star/lang/WrappedTargetException.hdl"

#include "com/sun/star/uno/Exception.hpp"
#include "com/sun/star/uno/Any.hxx"
#include "com/sun/star/uno/Type.hxx"
#include "cppu/unotype.hxx"
#include "osl/mutex.hxx"

namespace com { namespace sun { namespace star { namespace lang {

inline WrappedTargetException::WrappedTargetException() SAL_THROW( () )
    : ::com::sun::star::uno::Exception()
    , TargetException()
{
    ::cppu::UnoType< ::com::sun::star::lang::WrappedTargetException >::get();
}

inline WrappedTargetException::WrappedTargetException(const ::rtl::OUString& Message_, const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >& Context_, const ::com::sun::star::uno::Any& TargetException_) SAL_THROW( () )
    : ::com::sun::star::uno::Exception(Message_, Context_)
    , TargetException(TargetException_)
{
    ::cppu::UnoType< ::com::sun::star::lang::WrappedTargetException >::get();
}

WrappedTargetException::WrappedTargetException(WrappedTargetException const & the_other): ::com::sun::star::uno::Exception(the_other), TargetException(the_other.TargetException) {}

WrappedTargetException::~WrappedTargetException() {}

WrappedTargetException & WrappedTargetException::operator =(WrappedTargetException const & the_other) {
    //TODO: Just like its implicitly-defined counterpart, this function definition is not exception-safe
    ::com::sun::star::uno::Exception::operator =(the_other);
    TargetException = the_other.TargetException;
    return *this;
}

} } } }

namespace com { namespace sun { namespace star { namespace lang {

inline ::com::sun::star::uno::Type const & cppu_detail_getUnoType(::com::sun::star::lang::WrappedTargetException const *) {
    static ::com::sun::star::uno::Type * the_pType = 0;
    if (the_pType == 0)
    {
        ::osl::MutexGuard aGuard( ::osl::Mutex::getGlobalMutex() );
        if (the_pType == 0)
        {
            ::rtl::OUString sTypeName( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.lang.WrappedTargetException") );

            // Start inline typedescription generation
            typelib_TypeDescription * pTD = 0;
            const ::com::sun::star::uno::Type& rSuperType = ::cppu::UnoType< ::com::sun::star::uno::Exception >::get();

            typelib_CompoundMember_Init aMembers[1];
            ::rtl::OUString sMemberType0( RTL_CONSTASCII_USTRINGPARAM("any") );
            ::rtl::OUString sMemberName0( RTL_CONSTASCII_USTRINGPARAM("TargetException") );
            aMembers[0].eTypeClass = (typelib_TypeClass)::com::sun::star::uno::TypeClass_ANY;
            aMembers[0].pTypeName = sMemberType0.pData;
            aMembers[0].pMemberName = sMemberName0.pData;

            typelib_typedescription_new(
                &pTD,
                (typelib_TypeClass)::com::sun::star::uno::TypeClass_EXCEPTION, sTypeName.pData,
                rSuperType.getTypeLibType(),
                1,
                aMembers );

            typelib_typedescription_register( (typelib_TypeDescription**)&pTD );

            typelib_typedescription_release( pTD );
            // End inline typedescription generation

            static ::com::sun::star::uno::Type the_staticType( ::com::sun::star::uno::TypeClass_EXCEPTION, sTypeName );
            the_pType = &the_staticType;
        }
    }

    return *the_pType;
}

} } } }

inline ::com::sun::star::uno::Type const & SAL_CALL getCppuType(::com::sun::star::lang::WrappedTargetException const *) SAL_THROW(()) {
    return ::cppu::UnoType< ::com::sun::star::lang::WrappedTargetException >::get();
}

#endif // INCLUDED_COM_SUN_STAR_LANG_WRAPPEDTARGETEXCEPTION_HPP
