#ifndef INCLUDED_COM_SUN_STAR_REGISTRY_INVALIDREGISTRYEXCEPTION_HPP
#define INCLUDED_COM_SUN_STAR_REGISTRY_INVALIDREGISTRYEXCEPTION_HPP

#include "sal/config.h"

#include "com/sun/star/registry/InvalidRegistryException.hdl"

#include "com/sun/star/uno/Exception.hpp"
#include "com/sun/star/uno/Type.hxx"
#include "cppu/unotype.hxx"
#include "osl/mutex.hxx"

namespace com { namespace sun { namespace star { namespace registry {

inline InvalidRegistryException::InvalidRegistryException() SAL_THROW( () )
    : ::com::sun::star::uno::Exception()
{
    ::cppu::UnoType< ::com::sun::star::registry::InvalidRegistryException >::get();
}

inline InvalidRegistryException::InvalidRegistryException(const ::rtl::OUString& Message_, const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >& Context_) SAL_THROW( () )
    : ::com::sun::star::uno::Exception(Message_, Context_)
{
    ::cppu::UnoType< ::com::sun::star::registry::InvalidRegistryException >::get();
}

InvalidRegistryException::InvalidRegistryException(InvalidRegistryException const & the_other): ::com::sun::star::uno::Exception(the_other) {}

InvalidRegistryException::~InvalidRegistryException() {}

InvalidRegistryException & InvalidRegistryException::operator =(InvalidRegistryException const & the_other) {
    //TODO: Just like its implicitly-defined counterpart, this function definition is not exception-safe
    ::com::sun::star::uno::Exception::operator =(the_other);
    return *this;
}

} } } }

namespace com { namespace sun { namespace star { namespace registry {

inline ::com::sun::star::uno::Type const & cppu_detail_getUnoType(::com::sun::star::registry::InvalidRegistryException const *) {
    static ::com::sun::star::uno::Type * the_pType = 0;
    if (the_pType == 0)
    {
        ::osl::MutexGuard aGuard( ::osl::Mutex::getGlobalMutex() );
        if (the_pType == 0)
        {
            ::rtl::OUString sTypeName( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.registry.InvalidRegistryException") );

            // Start inline typedescription generation
            typelib_TypeDescription * pTD = 0;
            const ::com::sun::star::uno::Type& rSuperType = ::cppu::UnoType< ::com::sun::star::uno::Exception >::get();

            typelib_typedescription_new(
                &pTD,
                (typelib_TypeClass)::com::sun::star::uno::TypeClass_EXCEPTION, sTypeName.pData,
                rSuperType.getTypeLibType(),
                0,
                0 );

            typelib_typedescription_register( (typelib_TypeDescription**)&pTD );

            typelib_typedescription_release( pTD );
            // End inline typedescription generation

            static ::com::sun::star::uno::Type the_staticType( ::com::sun::star::uno::TypeClass_EXCEPTION, sTypeName );
            the_pType = &the_staticType;
        }
    }

    return *the_pType;
}

} } } }

inline ::com::sun::star::uno::Type const & SAL_CALL getCppuType(::com::sun::star::registry::InvalidRegistryException const *) SAL_THROW(()) {
    return ::cppu::UnoType< ::com::sun::star::registry::InvalidRegistryException >::get();
}

#endif // INCLUDED_COM_SUN_STAR_REGISTRY_INVALIDREGISTRYEXCEPTION_HPP
